<%
metamodel http://www.eclipse.org/uml2/2.0.0/UML

import org.soyatec.generation.acceleo.template.services.UmlServices
import org.soyatec.generation.acceleo.template.lib.interfaceScript
import org.soyatec.generation.acceleo.template.lib.common
import org.soyatec.generation.acceleo.template.lib.attributeScript
import org.soyatec.generation.acceleo.template.lib.methodScript
import org.soyatec.generation.acceleo.template.lib.classBodyJava
import org.soyatec.generation.acceleo.template.lib.classScript
%>

<%script type="Interface" name="fullFilePath"%>
<%if (!hasStereotype("NoGenCode")
		&& (!package.hasStereotype("NoGenCode"))){%>
<%packagePath("/")%>/<%name%>.java
<%}%>

<%script type="uml.Interface" name="interfaceJava" file="<%fullFilePath%>"%>
<%if (eContainer.eClass.name != "Model"){%>
<%if (packagePath(".") == null || packagePath(".").length() == 0){%>
<%--Display nothing when package name is null --%>
<%}else{%>
package <%packagePath(".")%>;
<%}%>
<%}%>
<%-- Generate import of interface --------------------------------------------%>
<%genImport%>

<%-- Generate comment of interface if exist ----------------------------------%>
<%if (ownedComment != null){%>
/**
 <%for (ownedComment){%>
 * <%body%>.
 <%}%>
 */
<%}else{%>
<%}%>
<%-- Interface declaration ---------------------------------------------------%>
<%genVisibility%>interface <%name%> <%genInherit%>{

<%-- Generate attributes -----------------------------------------------------%>
	<%for (ownedAttribute){%><%if (!hasStereotype("NoGenCode")){%>
	<%if (ownedComment != null){%>
	/**
	 <%for (ownedComment){%>
	 * <%body%>.
	 <%}%>
	 */
	<%}else{%>
	<%}%>
    <%genModifier%><%genToJavaType%><%name%><%genEqualDefValue%>;
	<%}%><%}%>

<%-- Generate methods --------------------------------------------------------%>
	<%for (ownedOperation){%><%if (!hasStereotype("NoGenCode")){%>
    /**
     <%if (ownedComment != null){%>
	 <%for (ownedComment){%>
	 * <%body%>.
	 <%}%>
	 <%}else{%>
	 <%}%>
     *
     <%for (ownedParameter){%><%if (direction != "return"){%>
     * @param <%name%><%genComment%>
	 <%}%><%}%>
	 <%for (ownedParameter){%><%if (direction == "return"){%>
     * @return <%name%><%genComment%>
	 <%}%><%}%>
     */
    <%genModifier%><%genToJavaType%><%name%>(<%genMethodParam%>) <%genException%>;

	<%}%><%}%>
	
<%-- Generate all inner class -----------------------------------------------%>
    <%for (ownedMember.filter("Class").select("!isBehavior")){%>
    // Inner class <%name%>.
    <%genModifier%>class <%name%> <%genInherit%><%genInterface%>{
    <%classBodyJava%>
	}
<%}%>
}

